<?php
  session_start();

  //get headers and page content
  include 'inc_db_connection_open.php';
  $query = "SELECT displayed_text FROM Webpage_Headings WHERE identification_page='Images' ORDER BY identification_element ASC;";
  $pageHeadings = pg_query($dbcnx, $query);
  include 'inc_db_connection_close.php';
?>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
  <head>
    <!-- Title will be automatically entered from database -->
    <title><?php $ph = pg_fetch_row($pageHeadings, 0); echo $ph[0]; ?></title>
    <meta name="keywords" content="alt-text, alt text, alternative text, text alternative, image, description, caption, longdesc" />
    <!--[if IE]>
    <link rel="stylesheet" href="tatistyleIE.css" type="text/css">
    <![endif]-->
    <!--[if !IE]> -->
    <link rel="stylesheet" href="tatistyle.css" type="text/css">
    <!-- <![endif]-->
    <meta http-equiv="refresh" content="1260">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.0/jquery.js" type="text/javascript"></script>
    <script type='text/javascript'>
      $(document).ready(function(){
//alert("Point 1.");
        $("#images").change(function(e){
          e.preventDefault();
          checkImageSelection();
        });
        $("#components").change(function(e){
          e.preventDefault();
          checkComponentSelection();
        });
      });

      function checkImageSelection()
      {
//alert("checking image selection");
        var selected_val=$("#images").val();
//alert(selected_val);

        if(selected_val == "")
        {
          //Selected the label for drop down menu. Clear everything and disable components list.
//alert("Disable everything");
          $("#filelocation").val("");
          $("#fileSelection").val("");
          $("textarea").val("");
          $("#components").attr('disabled', 'disabled');
        } else if (selected_val == "New")
        {
          //Want to create new image. Prompt for new image name and add to list.
//alert("get new image name");
          var newImagename = prompt("<?php $ph = pg_fetch_row($pageHeadings, 14); echo $ph[0]; ?>","");
          if( newImagename != null && newImagename != "")
          {
            if(newImagename.length > 50)
            {
              var msg = document.getElementById("message");
              msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 29); echo $ph[0]; ?></p>";
            } else {
              $("#images").append("<option id=\"temp\" value=\"NewImage:" + newImagename + "\" selected>" + newImagename + "</option>");
//alert("added new image")
            }
          }
          //Clear everything and disable components list.
          $("#filelocation").val("");
          $("#fileSelection").val("");
          $("textarea").val("");
          $("#components").attr('disabled', 'disabled');
        } else
        {
          // selected an existing image. Load information from database.
//alert("changing components");
          $("#buttonpress").val("loadImage");
          $("#imginfo").submit();
        }
      }

      function checkComponentSelection()
      {
//alert("checking component selection");
        var selected_val=$("#components").val();
//alert(selected_val);
        if(selected_val == "New")
        {
          //prompt for new component name and then add to database.
          var newCompname = prompt("<?php $ph = pg_fetch_row($pageHeadings, 17); echo $ph[0]; ?>", "");
          if( newCompname != null && newCompname != "" )
          {
            if(newCompname.length > 50)
            {
              var msg = document.getElementById("message");
              msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 30); echo $ph[0]; ?></p>";
            } else {
//alert(newCompname);
              $("#components").append("<option id=\"" + newCompname + "\" value=\"" + newCompname + "\" selected>" + newCompname + "</option>");
              $("#buttonpress").val("addComponent");
              $("#imginfo").submit();
            }
          }
        }
      }

      function checkChangeImageName()
      {
//alert("checking change image name");
        var selected_val=$("#images").val();
//alert(selected_val);
        if(selected_val == "")
        {
          //alert("You must select an image before changing the image name.");
          var msg = document.getElementById("message");
          msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 15); echo $ph[0]; ?></p>";
        } else
        {
          var newImagename = prompt("<?php $ph = pg_fetch_row($pageHeadings, 14); echo $ph[0]; ?>", "");
          if( newImagename != null && newImagename != "")
          {
            if(newImagename.length > 50)
            {
              var msg = document.getElementById("message");
              msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 29); echo $ph[0]; ?></p>";
            } else if (selected_val.substring(0, 9) == "NewImage:")
            {
              //selected a new image not yet in database.
              $("#images > option:selected").val("NewImage:" + newImagename);
              $("#images > option:selected").text(newImagename);
//alert("changed new image name")
            } else
            {
              //Selected an existing image in database
//alert("changing name");
              $("#images > option:selected").val(newImagename);
              $("#buttonpress").val("changeImageName");
              $("#imginfo").submit();
            }
          }
        }
      }

      function checkDeleteImage()
      {
//alert("checking delete image");
        var selected_val=$("#images").val();
//alert(selected_val);
        if(selected_val == "")
        {
          //alert("You must select an image before changing the image name.");
          var msg = document.getElementById("message");
          msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 16); echo $ph[0]; ?></p>";
        } else if (selected_val.substring(0, 9) == "NewImage:")
        {
          //selected a new image not yet in database.
          $("#images > option:selected").remove();
//alert("removed new image name")
        } else
        {
          //Selected an existing image in database
//alert("deleting image");
          $("#buttonpress").val("deleteImage");
          $("#imginfo").submit();
        }
      }

      function logout()
      {
        $("#buttonpress").val("logout");
        $("#imginfo").submit();
      }
    </script>
    <script type="text/javascript">
      function checkSaveForm()
      {
//alert("Checking Save form fields.");
        //Need to check if an image was selected.
        var selectedImg;
        for(counter = 0; counter < document.imginfo.images.options.length; counter++)
        {
          if(document.imginfo.images.options[counter].selected)
          {
            selectedImg = document.imginfo.images.options[counter].value;
            break;
          }
        }
        if(selectedImg == "" || selectedImg == "New")
        {
          //Image not selected.
          //alert("Please select an image to save.");
          var msg = document.getElementById("message");
          msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 22); echo $ph[0]; ?></p>";
        } else if(document.imginfo.filelocation.value == "")
        {
          //alert("Please specify the image file location.");
          var msg = document.getElementById("message");
          msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 23); echo $ph[0]; ?></p>";
          //return false;
        } else
        {
//alert("everything okay");
/*
          if(document.imginfo.fileSelection.value != "")
          {
            var location = document.imginfo.fileSelection.value;
//alert("location" + location);
            var pos = location.lastIndexOf("\\");
//alert("pos 1: " + pos);
            if(pos == -1)
            {
              pos = location.lastIndexOf("/");
//alert("pos 2: " + pos);
            }
            location = location.substr(pos+1);
//alert("location: " + location);
            document.imginfo.filelocation.value = location;
          }
*/
          document.imginfo.buttonpress.value = "save";
          document.imginfo.submit();
        }
      }

      function checkChangeComponentName()
      {
        if(document.imginfo.components.value == "" || document.imginfo.components.value == "New")
        {
          //alert("You must select a component before changing its name.");
          var msg = document.getElementById("message");
          msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 18); echo $ph[0]; ?></p>";
        } else if(document.imginfo.components.value == "Whole Image")
        {
          //alert("The \"Whole Image\" component is a default component and cannot be changed. Please try another component.");
          var msg = document.getElementById("message");
          msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 19); echo $ph[0]; ?></p>";
        } else
        {
          //Selected an existing component in database
          var newCompname = prompt("<?php $ph = pg_fetch_row($pageHeadings, 17); echo $ph[0]; ?>", "");
          if( newCompname != null && newCompname != "")
          {
            if(newCompname.length > 50)
            {
              var msg = document.getElementById("message");
              msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 30); echo $ph[0]; ?></p>";
            } else
            {
//alert("changing name");
              for(counter = 0; counter < document.imginfo.components.options.length; counter++)
              {
                if(document.imginfo.components.options[counter].selected)
                {
                  document.imginfo.components.options[counter].value = newCompname;
                  break;
                }
              }
              document.imginfo.buttonpress.value = "changeCompName";
              document.imginfo.submit();
            }
          }
        }
      }

      function checkDeleteComponent()
      {
        if(document.imginfo.components.value == "" || document.imginfo.components.value == "New")
        {
          //alert("You must select a component before deleting it.");
          var msg = document.getElementById("message");
          msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 20); echo $ph[0]; ?></p>";
        } else if(document.imginfo.components.value == "Whole Image")
        {
          //alert("The \"Whole Image\" component is a default component and cannot be deleted. Please try another component.");
          var msg = document.getElementById("message");
          msg.innerHTML = "<p id=\"systemmessage\"><?php $ph = pg_fetch_row($pageHeadings, 21); echo $ph[0]; ?></p>";
        } else
        {
          document.imginfo.buttonpress.value = "deleteComponent";
          document.imginfo.submit();
        }
      }

      function openImageWindow()
      {
        window.open(document.imginfo.filelocation.value);
      }
    </script>
  </head>

  <body id="page4">

    <?php
      $systemmessage = "";

      include_once "inc_func_updateLastModified.php";
      include "inc_func_Images_saveAnswers.php";
      include_once 'inc_func_addComponent.php';

      function loadImage()
      {
        updateLastModified($_SESSION['username'], $_POST['images'], "Whole Image", "Purpose");
      }

      function newComp()
      {
//echo "new component name: " . $_POST['components'] . "<br>\n";
        $results = addComponent($_SESSION['username'], $_POST['images'], $_POST['components']);
        if(!$results)
        {
          //Component not added. Display error message.
          global $systemmessage, $pageHeadings;
          $ph = pg_fetch_row($pageHeadings, 24);
          $systemmessage = "<p id=\"systemmessage\">" . $ph[0] . "</p>\n";
        }else
        {
          //Component added. Display success message.
          global $systemmessage, $pageHeadings;
          $ph = pg_fetch_row($pageHeadings, 25);
          $systemmessage = "<p id=\"systemmessage\">" . $_POST['components'] . $ph[0] . "</p>\n";
        }

        //Update Accounts table with this component and image as the last modified.
        updateLastModified($_SESSION['username'], $_POST['images'], $_POST['components'], "Physical Object");

        //Update image statuses to false.
        include 'inc_db_connection_open.php';
        $query = "UPDATE Images SET image_status=false, allocation_status=false WHERE user_name='"
               . $_SESSION['username'] . "', image_name='" . $_POST['images'] . "';";
        pg_query($dbcnx, $query);
        include 'inc_db_connection_close.php';
      }

      function changeImageName()
      {
        include 'inc_db_connection_open.php';
        //Update Images table, which then cascades to the other tables.
        $query = "UPDATE images SET image_name='" . pg_escape_string($_POST['images']) . "' WHERE"
               . " image_name='" . $_SESSION['last_image'] . "';";
//echo $query . "<br>\n";
        $results = pg_query($dbcnx, $query);
        if(!$results)
        {
          //error occurred while updating image name. Display error message.
          global $systemmessage, $pageHeadings;
          $ph = pg_fetch_row($pageHeadings, 24);
          $systemmessage = "<p id=\"systemmessage\">" . $ph[0] . "</p>\n";
        } else
        {
          //Update Accounts table with image as the last modified.
          updateLastModified($_SESSION['username'], pg_escape_string($_POST['images']), $_SESSION['last_component'], $_SESSION['last_question']);
        }

        include 'inc_db_connection_close.php';
      }

      function deleteImage()
      {
        //change the username of the image to be "deleted".
        //generate new username.
        $deletedusername = "deleted" . time();

        //create new user account with the new username only
        include 'inc_db_connection_open.php';
        $query = "INSERT INTO Accounts (user_name,acct_type) VALUES ('" . $deletedusername . "','user');";
//echo $query . "<br>\n";
        $results = pg_query($dbcnx, $query);

        if(!$results)
        {
          //Error occurred while creating the new deleted account. Display error message.
          global $systemmessage, $pageHeadings;
          $ph = pg_fetch_row($pageHeadings, 26);
          $systemmessage = "<p id=\"systemmessage\">" . $ph[0] . "</p>\n";
        } else
        {
          //Update the images table with new username, which will cascade to the other tables.
          $query = "UPDATE Images SET user_name='" . $deletedusername
                 . "' WHERE user_name='" . $_SESSION['username']
                 . "' AND image_name='" . $_SESSION['last_image'] . "';";
//echo $query . "<br>\n";
          $results = pg_query($dbcnx, $query);
          if(!$results)
          {
            //An error occurred. Display error message.
            global $systemmessage, $pageHeadings;
            $ph = pg_fetch_row($pageHeadings, 26);
            $systemmessage = "<p id=\"systemmessage\">" . $ph[0] . "</p>\n";
          } else
          {
            //Update user's Accounts table with empty last modified information.
            updateLastModified($_SESSION['username'], "", "", "");
            global $systemmessage, $pageHeadings;
            $ph = pg_fetch_row($pageHeadings, 27);
            $systemmessage = "<p id=\"systemmessage\">" . $ph[0] . "</p>\n";
          }
        }

        include 'inc_db_connection_close.php';
      }

      function changeComponentName()
      {
        include 'inc_db_connection_open.php';
        //Update Components table, which then cascades to the other tables.
        $query = "UPDATE components SET image_component='" . pg_escape_string($_POST['components'])
               . "' WHERE image_name='" . $_SESSION['last_image']
               . "' AND image_component='" . $_SESSION['last_component'] . "';";
//echo $query . "<br>\n";
        $results = pg_query($dbcnx, $query);
        if(!$results)
        {
          //an error occurred while changing the component name. Display error message.
          global $systemmessage, $pageHeadings;
          $ph = pg_fetch_row($pageHeadings, 24);
          $systemmessage = "<p id=\"systemmessage\">" . $ph[0] . "</p>\n";
        } else
        {
          //Update Accounts table with this component and image as the last modified.
          updateLastModified($_SESSION['username'], $_POST['images'], pg_escape_string($_POST['components']), $_SESSION['last_question']);
        }

        include 'inc_db_connection_close.php';
      }

      function deleteComponent()
      {
        include 'inc_db_connection_open.php';
        //delete from components table, which then cascades to the other tables.
        $query = "DELETE FROM components WHERE user_name='" . $_SESSION['username']
               . "' AND image_name='" . $_POST['images']
               . "' AND image_component='" . $_POST['components'] . "';";
//echo $query . "<br>\n";

        $results = pg_query($dbcnx, $query);
        if(!$results)
        {
          global $systemmessage, $pageHeadings;
          $ph = pg_fetch_row($pageHeadings, 26);
          $systemmessage = "<p id=\"systemmessage\">" . $ph[0] . "</p>\n";
        } else
        {
          //Update Accounts table with Whole Image and image as the last modified.
          updateLastModified($_SESSION['username'], $_POST['images'], "Whole Image", "Purpose");

          //check if all components are done and need to update image status.
          $query = "SELECT count(*) FROM Components WHERE user_name='"
                 . $_SESSION['username'] . "' AND image_name='" . $_POST['images']
                 . "' AND component_status=false;";
//echo $query . "<br>\n";
          $results = pg_query($dbcnx, $query);
          $count = pg_fetch_row($results);

          if($count[0] == 0)
          {
            //Update image status
            $query = "UPDATE Images SET image_status=true WHERE user_name='"
                   . $_SESSION['username'] . "' AND image_name='" . $_POST['images']
                   . "';";
  //echo $query . "<br>\n";
            pg_query($dbcnx, $query);
          }
        }

        include 'inc_db_connection_close.php';
      }

      if( $_POST['buttonpress'] == "save")
      {
//echo "Saving image information.<br>\n";
        saveAnswers();
      } else if( $_POST['buttonpress'] == "loadImage" )
      {
//echo "loading image information.<br>\n";
        loadImage();
      } else if( $_POST['buttonpress'] == "changeImageName")
      {
//echo "Changing image name.<br>\n";
        changeImageName();
      } else if( $_POST['buttonpress'] == "deleteImage")
      {
//echo "Deleting image.<br>\n";
        deleteImage();
      } else if( $_POST['buttonpress'] == "changeCompName")
      {
//echo "Changing component name.<br>\n";
        changeComponentName();
      } else if( $_POST['buttonpress'] == "deleteComponent")
      {
//echo "Deleting component.<br>\n";
        deleteComponent();
      } else if( $_POST['buttonpress'] == "addComponent")
      {
//echo "Creating component.<br>\n";
        newComp();
      }

      // display the header
      include 'header.php';

      // display the tab menus
      include 'menu.php';

      echo "<div name=\"message\" id=\"message\">\n";
      if($systemmessage != ""){
        echo $systemmessage;
      }
      echo "</div>\n";
    ?>

    <!-- Actual Content begins -->

    <form id="imginfo" name="imginfo" method="post">
      <input type="hidden" id="buttonpress" name="buttonpress" value=""/>
      <table>
        <tr>
          <td>
              <?php
                include 'inc_func_generateImageListMenu.php';
                generateImageListMenu(false);
              ?>
          </td>
          <td>
            <input type="button" id="changeImageName" name="changeImageName" value="<?php $ph = pg_fetch_row($pageHeadings, 5); echo $ph[0]; ?>" onclick="checkChangeImageName();"/>
            <input type="button" id="deleteImage" name="deleteImage" value="<?php $ph = pg_fetch_row($pageHeadings, 6); echo $ph[0]; ?>" onclick="checkDeleteImage();"/>
          </td>
        </tr>
        <tr>
          <td>
              <?php
                include 'inc_func_generateComponentListMenu.php';
                generateComponentListMenu(false);
              ?>
          </td>
          <td>
            <input type="button" id="changeCompName" name="changeCompName" value="<?php $ph = pg_fetch_row($pageHeadings, 7); echo $ph[0]; ?>" onclick="checkChangeComponentName();"/>
            <input type="button" id="deleteComp" name="deleteComp" value="<?php $ph = pg_fetch_row($pageHeadings, 8); echo $ph[0]; ?>" onclick="checkDeleteComponent();"/>
          </td>
        </tr>
        <tr>
          <th>
            <?php $ph = pg_fetch_row($pageHeadings, 9); echo $ph[0]; ?>
          </th>
<!--
          <td>
            <input type="file" size="65px" id="fileSelection" />
          </td>
        </tr>
        <tr>
-->
          <td>
            <?php
              echo "<input type=\"text\" size=\"65px\" name=\"filelocation\""
                 . " id=\"filelocation\" value=\"";
              // Load information from database.
              include 'inc_db_connection_open.php';

              $query = "SELECT image_location FROM images WHERE user_name='"
                     . $_SESSION['username'] . "' AND image_name='"
                     . $_SESSION['last_image'] . "';";
//echo $query . "<br>\n";
              $results = pg_query($dbcnx, $query) or die("Error in query: $query.");
              $row = pg_fetch_array($results, NULL, PGSQL_ASSOC);
              echo $row['image_location'];
              include 'inc_db_connection_close.php';

              echo "\" />\n";
            ?>
            <input type="button" name="openImage" value="<?php $ph = pg_fetch_row($pageHeadings, 10); echo $ph[0]; ?>" onclick="openImageWindow();"/>
          </td>
        </tr>
        <tr>
          <th colspan="2">
            <?php $ph = pg_fetch_row($pageHeadings, 11); echo $ph[0]; ?>
          </th>
        </tr>
        <tr>
          <td colspan="2">
            <textarea name="imagecaption" rows="3" ><?php
                // Load information from database.
                include 'inc_db_connection_open.php';

                $query = "SELECT image_caption FROM images WHERE user_name='"
                       . $_SESSION['username'] . "' AND image_name='"
                       . $_SESSION['last_image'] . "';";
//echo $query . "<br>\n";
                $results = pg_query($dbcnx, $query) or die("Error in query: $query.");
                $row = pg_fetch_array($results, NULL, PGSQL_ASSOC);
                echo $row['image_caption'];
                include 'inc_db_connection_close.php';
            ?></textarea>
          </td>
        </tr>
        <tr>
          <th colspan="2">
            <?php $ph = pg_fetch_row($pageHeadings, 12); echo $ph[0]; ?>
          </th>
        </tr>
        <tr>
          <td colspan="2">
            <textarea name="maintext" rows="3" ><?php
                // Load information from database.
                include 'inc_db_connection_open.php';

                $query = "SELECT document_text FROM images WHERE user_name='"
                       . $_SESSION['username'] . "' AND image_name='"
                       . $_SESSION['last_image'] . "';";
//echo $query . "<br>\n";
                $results = pg_query($dbcnx, $query) or die("Error in query: $query.");
                $row = pg_fetch_array($results, NULL, PGSQL_ASSOC);
                echo $row['document_text'];
                include 'inc_db_connection_close.php';
            ?></textarea>
          </td>
        </tr>
        <tr>
          <td colspan="2">
            <input type="button" name="saveChanges" value="<?php $ph = pg_fetch_row($pageHeadings, 13); echo $ph[0]; ?>" onclick="checkSaveForm()"/>
          </td>
        </tr>
      </table>
    </form>

    <?php include 'footer.php'; ?>
  </body>
</html>